/*
  $Id: DataStruct.cpp 4269 2009-02-09 20:08:05Z rares $

  Copyright (C) 2009 by The Regents of the University of California

  Redistribution of this file is permitted under the terms of the
  BSD license

  Date: 09/01/2005
  Author: Rares Vernica <rares (at) ics.uci.edu> 
*/

#include "DataStruct.h"

unsigned global_timeIO=0;

/* ----- pair ----- */

// --- operator<<

ostream& operator<<(ostream& out, const PairRegion& pair)
{
  return out<<"["<<pair.first<<", "<<pair.second<<"]";
}

ostream& operator<<(ostream& out, const PairPoint& pair)
{
  return out<<"["<<pair.first<<", "<<pair.second<<"]";
}

ostream& operator<<(ostream& out, const RegionID& regid)
{
  return out<<"["<<regid.id<<", "<<(regid.index?"I":"L")<<", "<<regid.getRegion()<<"]";
}

ostream& operator<<(ostream& out, const RegionIDLevel& regidlevel)
{
  return out<<"["<<regidlevel.id<<", "
	    <<(regidlevel.index?"I":"L")<<", "
	    <<regidlevel.getRegion()<<", "
	    <<regidlevel.level<<"]";
}

ostream& operator<<(ostream& out, const PairRegionID& pair)
{
  return out<<"["<<pair.first<<", "<<pair.second<<"]";
}

ostream& operator<<(ostream& out, const PairRegionIDLevel& pair)
{
  return out<<"["<<pair.first<<", "<<pair.second<<"]";
}
