/*
  $Id: Generator.cpp 4269 2009-02-09 20:08:05Z rares $

  Copyright (C) 2009 by The Regents of the University of California

  Redistribution of this file is permitted under the terms of the
  BSD license

  Date: 09/01/2005
  Author: Rares Vernica <rares (at) ics.uci.edu> 
*/

#include <tools/Tools.h>

#include <iostream>
#include <iterator>
#include <set>

using namespace std;

class Point
{
public:
  double m_w, m_x, m_y, m_z;
  
  Point(double w, double x, double y, double z): m_w(w), m_x(x), m_y(y), m_z(z)
  {
  }
};

ostream& operator<<(ostream& out, const Point& point) 
{
  return out<<point.m_w<<" "<<point.m_x<<" "<<point.m_y<<" "<<point.m_z;
}

bool operator<(const Point& a, const Point& b)
{
  return a.m_w<b.m_w?true:a.m_x<b.m_x?true:a.m_y<b.m_y?true:a.m_z<b.m_z?true:false;
}

int main(int argc, char** argv) 
{
  if (argc!=2) {
    cerr<<"Usage: "<<argv[0]<<" number_of_data."<<endl;
    return -1;
  }
  
  unsigned long numberOfObjects=atol(argv[1]);
  Tools::Random rnd;
  set<Point> data;
  
  for (unsigned long i=0; i<numberOfObjects; i++) {
    double w=rnd.nextUniformDouble();
    double x=rnd.nextUniformDouble();
    double y=rnd.nextUniformDouble();
    double z=rnd.nextUniformDouble();;
    Point p=Point(w, x, y, z);
    
    data.insert(p);
  }
  
  copy(data.begin(), data.end(), ostream_iterator<Point>(cout, "\n"));
  return 0;
}
