/*
  $Id: CreateIndex.h 4269 2009-02-09 20:08:05Z rares $

  Copyright (C) 2009 by The Regents of the University of California

  Redistribution of this file is permitted under the terms of the
  BSD license

  Date: 09/01/2005
  Author: Rares Vernica <rares (at) ics.uci.edu> 
*/

#ifndef _CreateIndex_
#define _CreateIndex_

#include <vector>
#include <tr1/unordered_map>

using namespace std;
using namespace tr1;

template <class Tuple, typename attr_type> 
void createIndex(const vector<Tuple> &vect,
		 unordered_multimap<attr_type, unsigned> &idx,
		 attr_type (*getTuple_attr)(const Tuple&)) 
{
  cerr << "building index..."; cerr.flush();
  for (unsigned i = 0; i < vect.size(); i++) 
    {
      idx.insert(typename unordered_multimap<attr_type, unsigned>::value_type(getTuple_attr(vect[i]), i));
    }
  cerr << " done (" << idx.size() << " entries, " << idx.size() * sizeof(idx) / 1024 << " Kb)" << endl;
}

#endif
