/*
  $Id: Join.cpp 4269 2009-02-09 20:08:05Z rares $

  Copyright (C) 2009 by The Regents of the University of California

  Redistribution of this file is permitted under the terms of the
  BSD license

  Date: 09/01/2005
  Author: Rares Vernica <rares (at) ics.uci.edu> 
*/

#include "setting.h"
#include "Dataset.h"
#include "ReadDataset.h"
#include "CreateIndex.h"
#include "Join.h"

#include "DatasetIMDB.h"
// #include "DatasetSynth.h"

#include <algorithm>

int main() 
{
  // for each dataset type
  for (unsigned i = 0; i < sizeof(datasets_directory) / sizeof(string); i++)
    {
      for (unsigned card = card_st; card <= card_en; card += card_in) 
	{
	  // cout << "dataset\t" << datasets_directory[i] << endl;
          // cout << "\tcard\t" << card << endl;
	  // char buff[256];
	  // sprintf(buff, "%02d", card);

	  string
	    datasetR_fullpath = datasets_path + datasets_directory[i] + 
	                        datasetR_filename + 
#ifdef _DatasetSynth_
	                        string(buff) + 
#endif
	                        datasets_fileext, 
	    datasetS_fullpath = datasets_path + datasets_directory[i] + 
	                        datasetS_filename + 
#ifdef _DatasetSynth_
	                        string(buff) + 
#endif
                                datasets_fileext;

	  for (unsigned j = 0; j < sizeof(out_skyline_filename) / sizeof(string); j++) 
	    {
	      out_skyline_fullpath[j] = out_path +  datasets_directory[i] + out_skyline_filename[j];
	      out_skyline_size_fullpath[j] = out_skyline_fullpath[j] + "_size";
	    }

	  VectTupleS *datasetS_full = new VectTupleS();
	  VectTupleS *datasetS;
      
#ifdef _DatasetIMDB_
	  readDataset(*datasetS_full, datasetS_fullpath);
	  random_shuffle(datasetS_full->begin(), datasetS_full->end());
	  datasetS  = new VectTupleS(datasetS_full->begin(), datasetS_full->begin() + size_S);
	  delete datasetS_full;
#else
	  readDataset(*datasetS_full, datasetS_fullpath, size_S);
	  datasetS = datasetS_full;
#endif

	  HashIdxUnsigned *indexS = new HashIdxUnsigned();  
	  createIndex(*datasetS, *indexS,  getTuple_attrJ);

	  // for each dataset size
	  for (unsigned size = size_R_st; size <= size_R_en; size += size_R_in)
	    {
	      cout << "size\t" << size << endl;

	      VectTupleR *datasetR_full = new VectTupleR();
	      VectTupleR *datasetR;

#ifdef _DatasetIMDB_
	      readDataset(*datasetR_full, datasetR_fullpath);
	      random_shuffle(datasetR_full->begin(), datasetR_full->end());
	      datasetR  = new VectTupleR(datasetR_full->begin(), datasetR_full->begin() + size);
	      delete datasetR_full;
#else
	      readDataset(*datasetR_full, datasetR_fullpath, size);
	      datasetR = datasetR_full;
#endif


	      HashIdxUnsigned *indexR = new HashIdxUnsigned();  
	      createIndex(*datasetR, *indexR,  getTuple_attrJ);

	      run(*datasetR, *datasetS, *indexR, *indexS, no_runs, size, card);

	      delete indexR;
	      delete datasetR;
	    }

	  delete indexS;
	  delete datasetS;
	}
      
    }

  return 0;
}
